      SUBROUTINE FINDV(T,VTP,N,V)
C     FINDV FINDS AND RETURNS A VELOCITY V CORRESPONDING TO A GIVEN T FROM A
C  GIVEN VELOCITY FUNCTION VTP (VELOCITY-TIME-PAIRS) N LONG.
C     THE FIRST VELOCITY OF VTP IS USED FOR ALL T'S BEFORE THE FIRST T OF VTP.
C  LIKEWISE, THE LAST VELOCITY OF VTP IS USED FOR ALL T'S AFTER THE LAAST
C  GIVEN IN THE VTP ARRAY.
C
C   COPYRIGHTED BY:
C  PAUL HENKART, SCRIPPS INSTITUTION OF OCEANOGRAPHY, APRIL 1980
C
c  mod 1 Apr 10 - remove arithmetic IF statements
c
      DIMENSION VTP(1)
C
      DO 100 I=1,N,2
      VX=VTP(I)
      TX=VTP(I+1)
c      IF(T-TX)100,200,10
      IF( t - tx .LT. 0 ) GOTO 100
      IF( t - tx .EQ. 0 ) GOTO 200
   10 IF(I.EQ.1) GO TO 200
      IF(VTP(I-1).EQ.VTP(I+1)) GO TO 300                                 /* WATCH OUT FOR DIVIDE BY 0 (CONSTANT V)
      VX=(T-VTP(I-1))/(VTP(I+1)-VTP(I-1))*(VTP(I)-VTP(I-2))+VTP(I-2)
      GO TO 200
  100 CONTINUE
  200 V=VX
      RETURN
  300 V=VTP(I-1)
      RETURN
      END
